# -*- coding: utf-8 -*-
"""
# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

This file provides a central place to tweak the solving algorithm.
"""

import sys

# The valid values of sets can either be split in half or into sets
# containing only one element.  This is tweakable by the following
# variables.
DIGIT_SPLIT_HALF = 'split-half'
DIGIT_SPLIT_SINGLETON = 'split-singleton'
DIGIT_SPLIT = DIGIT_SPLIT_SINGLETON

# Tweak explicit number representation
# If the cardinality of the Number is going to be lower than this, 
# start representing it exactly
MAX_EXPLICIT_NUMBERS = 1062

# Tweak PowerRule:
# This is going to be multiplied by the potence
POTENCE_LENGTH_LIMIT = 3 

# Return value for “very very large”
ALMOST_INFINITE = sys.maxint

# The value of this determines which method is used to select the next
# splittable cell.
SOLVER_NEXT_SPLITTABLE_SMALLEST   = 'smallest'
SOLVER_NEXT_SPLITTABLE_LARGEST    = 'largest'
SOLVER_NEXT_SPLITTABLE_FIRST      = 'first'
SOLVER_NEXT_SPLITTABLE_RANDOM     = 'random'
SOLVER_NEXT_SPLITTABLE_MOST_RULES = 'most related rules'
SOLVER_NEXT_SPLITTABLE = SOLVER_NEXT_SPLITTABLE_FIRST
